## mongodb 1.2.2

=== SConstruct ===
# -*- mode: python; -*-
# build file for 10gen db
# this request scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

import os
import sys
import imp
import types
import re
import shutil
import urllib
import urllib2
import buildscripts

# --- options ----
AddOption('--prefix',
          dest='prefix',
          type='string',
          nargs=1,
          action='store',
          metavar='DIR',
          help='installation prefix')

AddOption('--distname',
          dest='distname',
          type='string',
          nargs=1,
          action='store',
          metavar='DIR',
          help='dist name (0.8.0)')


AddOption( "--64",
           dest="force64",
           type="string",
           nargs=0,
           action="store",
           help="whether to force 64 bit" )


AddOption( "--32",
           dest="force32",
           type="string",
           nargs=0,
           action="store",
           help="whether to force 32 bit" )


AddOption( "--mm",
           dest="mm",
           type="string",
           nargs=0,
           action="store",
           help="use main memory instead of memory mapped files" )


AddOption( "--release",
           dest="release",
           type="string",
           nargs=0,
           action="store",
           help="relase build")


AddOption( "--static",
           dest="static",
           type="string",
           nargs=0,
           action="store",
           help="fully static build")


AddOption('--java',
          dest='javaHome',
          type='string',
          default="/opt/java/",
          nargs=1,
          action='store',
          metavar='DIR',
          help='java home')

AddOption('--nojni',
          dest='nojni',
          type="string",
          nargs=0,
          action="store",
          help="turn off jni support" )


AddOption('--usesm',
          dest='usesm',
          type="string",
          nargs=0,
          action="store",
          help="use spider monkey for javascript" )

AddOption('--usev8',
          dest='usev8',
          type="string",
          nargs=0,
          action="store",
          help="use v8 for javascript" )

AddOption('--usejvm',
          dest='usejvm',
          type="string",
          nargs=0,
          action="store",
          help="use java for javascript" )

AddOption( "--d",
           dest="debugBuild",
           type="string",
           nargs=0,
           action="store",
           help="debug build no optimization, etc..." )

AddOption( "--dd",
           dest="debugBuildAndLogging",
           type="string",
           nargs=0,
           action="store",
           help="debug build no optimization, additional debug logging, etc..." )

AddOption( "--recstore",
           dest="recstore",
           type="string",
           nargs=0,
           action="store",
           help="use new recstore" )

AddOption( "--noshell",
           dest="noshell",
           type="string",
           nargs=0,
           action="store",
           help="don't build shell" )

AddOption( "--extrapath",
           dest="extrapath",
           type="string",
           nargs=1,
           action="store",
           help="comma seperated list of add'l paths  (--extrapath /opt/foo/,/foo" )

AddOption( "--extralib",
           dest="extralib",
           type="string",
           nargs=1,
           action="store",
           help="comma seperated list of libraries  (--extralib js_static,readline" )

AddOption( "--cxx",
           dest="cxx",
           type="string",
           nargs=1,
           action="store",
           help="compiler to use" )


AddOption( "--boost-compiler",
           dest="boostCompiler",
           type="string",
           nargs=1,
           action="store",
           help="compiler used for boost (gcc41)" )

AddOption( "--boost-version",
           dest="boostVersion",
           type="string",
           nargs=1,
           action="store",
           help="boost version for linking(1_38)" )

AddOption( "--pg",
           dest="profile",
           type="string",
           nargs=0,
           action="store" )

# --- environment setup ---

def removeIfInList( lst , thing ):
    if thing in lst:
        lst.remove( thing )

def printLocalInfo():
    import sys, SCons
    print( "scons version: " + SCons.__version__ )
    print( "python version: " + " ".join( [ `i` for i in sys.version_info ] ) )

printLocalInfo()

boostLibs = [ "thread" , "filesystem" , "program_options" ]

onlyServer = len( COMMAND_LINE_TARGETS ) == 0 or ( len( COMMAND_LINE_TARGETS ) == 1 and str( COMMAND_LINE_TARGETS[0] ) in [ "mongod" , "mongos" , "test" ] )
nix = False
useJavaHome = False
linux = False
linux64  = False
darwin = False
windows = False
freebsd = False
solaris = False
force64 = not GetOption( "force64" ) is None
if not force64 and os.getcwd().endswith( "mongo-64" ):
    force64 = True
    print( "*** assuming you want a 64-bit build b/c of directory *** " )
msarch = None
if force64:
    msarch = "amd64"

force32 = not GetOption( "force32" ) is None
release = not GetOption( "release" ) is None
static = not GetOption( "static" ) is None

debugBuild = ( not GetOption( "debugBuild" ) is None ) or ( not GetOption( "debugBuildAndLogging" ) is None )
debugLogging = not GetOption( "debugBuildAndLogging" ) is None
noshell = not GetOption( "noshell" ) is None
nojni = not GetOption( "nojni" ) is None

usesm = not GetOption( "usesm" ) is None
usev8 = not GetOption( "usev8" ) is None
usejvm = not GetOption( "usejvm" ) is None

env = Environment( MSVS_ARCH=msarch , tools = ["default", "gch"], toolpath = '.' )
if GetOption( "cxx" ) is not None:
    env["CC"] = GetOption( "cxx" )
    env["CXX"] = GetOption( "cxx" )
env["LIBPATH"] = []

if GetOption( "recstore" ) != None:
    env.Append( CPPDEFINES=[ "_RECSTORE" ] )
env.Append( CPPDEFINES=[ "_SCONS" ] )
env.Append( CPPPATH=[ "." ] )



boostCompiler = GetOption( "boostCompiler" )
if boostCompiler is None:
    boostCompiler = ""
else:
    boostCompiler = "-" + boostCompiler

boostVersion = GetOption( "boostVersion" )
if boostVersion is None:
    boostVersion = ""
else:
    boostVersion = "-" + boostVersion

if ( usesm and usejvm ):
    print( "can't say usesm and usejvm at the same time" )
    Exit(1)

if ( not ( usesm or usejvm or usev8 ) ):
    usesm = True

if GetOption( "extrapath" ) is not None:
    for x in GetOption( "extrapath" ).split( "," ):
        env.Append( CPPPATH=[ x + "/include" ] )
        env.Append( LIBPATH=[ x + "/lib" ] )
    release = True

if GetOption( "extralib" ) is not None:
    for x in GetOption( "extralib" ).split( "," ):
        env.Append( LIBS=[ x ] )

# ------    SOURCE FILE SETUP -----------

commonFiles = Split( "stdafx.cpp buildinfo.cpp db/jsobj.cpp db/json.cpp db/commands.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp shell/mongo.cpp" )
commonFiles += [ "util/background.cpp" , "util/mmap.cpp" ,  "util/sock.cpp" ,  "util/util.cpp" , "util/message.cpp" , 
                 "util/assert_util.cpp" , "util/httpclient.cpp" , "util/md5main.cpp" , "util/base64.cpp", "util/debug_util.cpp"  ]
commonFiles += Glob( "util/*.c" )
commonFiles += Split( "client/connpool.cpp client/dbclient.cpp client/model.cpp client/parallel.cpp" )
commonFiles += [ "scripting/engine.cpp" ]

#mmap stuff

if GetOption( "mm" ) != None:
    commonFiles += [ "util/mmap_mm.cpp" ]
elif os.sys.platform == "win32":
    commonFiles += [ "util/mmap_win.cpp" ]
else:
    commonFiles += [ "util/mmap_posix.cpp" ]

if os.path.exists( "util/processinfo_" + os.sys.platform + ".cpp" ):
    commonFiles += [ "util/processinfo_" + os.sys.platform + ".cpp" ]
else:
    commonFiles += [ "util/processinfo_none.cpp" ]

coreDbFiles = []
coreServerFiles = [ "util/message_server_port.cpp" , "util/message_server_asio.cpp" ]

serverOnlyFiles = Split( "db/query.cpp db/update.cpp db/introspect.cpp db/btree.cpp db/clientcursor.cpp db/tests.cpp db/repl.cpp db/btreecursor.cpp db/cloner.cpp db/namespace.cpp db/matcher.cpp db/dbeval.cpp db/dbwebserver.cpp db/dbinfo.cpp db/dbhelpers.cpp db/instance.cpp db/pdfile.cpp db/cursor.cpp db/security_commands.cpp db/client.cpp db/security.cpp util/miniwebserver.cpp db/storage.cpp db/reccache.cpp db/queryoptimizer.cpp db/extsort.cpp db/mr.cpp s/d_util.cpp" )
serverOnlyFiles += Glob( "db/dbcommands*.cpp" )

if usesm:
    commonFiles += [ "scripting/engine_spidermonkey.cpp" ]
    nojni = True
elif usev8:
    commonFiles += [ Glob( "scripting/*v8*.cpp" ) ]
    nojni = True
elif not nojni:
    commonFiles += [ "scripting/engine_java.cpp" ]
else:
    commonFiles += [ "scripting/engine_none.cpp" ]
    nojni = True

coreShardFiles = []
shardServerFiles = coreShardFiles + Glob( "s/strategy*.cpp" ) + [ "s/commands_admin.cpp" , "s/commands_public.cpp" , "s/request.cpp" ,  "s/cursors.cpp" ,  "s/server.cpp" , "s/chunk.cpp" , "s/shardkey.cpp" , "s/config.cpp"  ]
shardServerFiles += [ "client/quorum.cpp" ]
serverOnlyFiles += coreShardFiles + [ "s/d_logic.cpp" ]

serverOnlyFiles += [ "db/module.cpp" ] + Glob( "db/modules/*.cpp" )

modules = []

for x in os.listdir( "db/modules/" ):
    if x.find( "." ) >= 0:
        continue
    print( "adding module: " + x )
    modRoot = "db/modules/" + x + "/"
    serverOnlyFiles += Glob( modRoot + "src/*.cpp" )
    modBuildFile = modRoot + "build.py"
    if os.path.exists( modBuildFile ):
        modules += [ imp.load_module( "module_" + x , open( modBuildFile , "r" ) , modBuildFile , ( ".py" , "r" , imp.PY_SOURCE  ) ) ]

allClientFiles = commonFiles + coreDbFiles + [ "client/clientOnly.cpp" , "client/gridfs.cpp" , "s/d_util.cpp" ];

allCXXFiles = allClientFiles + coreShardFiles + shardServerFiles + serverOnlyFiles;

# ---- other build setup -----

platform = os.sys.platform
if "uname" in dir(os):
    processor = os.uname()[4]
else:
    processor = "i386"

if force32:
    processor = "i386"
if force64:
    processor = "x86_64"

DEFAULT_INSTALl_DIR = "/usr/local"
installDir = DEFAULT_INSTALl_DIR
nixLibPrefix = "lib"

distName = GetOption( "distname" )
dontReplacePackage = False

javaHome = GetOption( "javaHome" )
javaVersion = "i386";
javaLibs = []

distBuild = len( COMMAND_LINE_TARGETS ) == 1 and ( str( COMMAND_LINE_TARGETS[0] ) == "s3dist" or str( COMMAND_LINE_TARGETS[0] ) == "dist" )
if distBuild:
    release = True

if GetOption( "prefix" ):
    installDir = GetOption( "prefix" )

def findVersion( root , choices ):
    for c in choices:
        if ( os.path.exists( root + c ) ):
            return root + c
    raise "can't find a version of [" + root + "] choices: " + choices

def choosePathExist( choices , default=None):
    for c in choices:
        if c != None and os.path.exists( c ):
            return c
    return default

if "darwin" == os.sys.platform:
    darwin = True
    platform = "osx" # prettier than darwin

    if usejvm:
        env.Append( CPPPATH=[ "-I/System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK/Headers/" ] )

    if not nojni:
        env.Append( FRAMEWORKS=["JavaVM"] )

    if env["CXX"] is None:
        if os.path.exists( "/usr/bin/g++-4.2" ):
            env["CXX"] = "g++-4.2"

    nix = True

    if force64:
        env.Append( CPPPATH=["/usr/64/include"] )
        env.Append( LIBPATH=["/usr/64/lib"] )
        if installDir == DEFAULT_INSTALl_DIR and not distBuild:
            installDir = "/usr/64/"
    else:
        env.Append( CPPPATH=[ "/sw/include" , "/opt/local/include"] )
        env.Append( LIBPATH=["/sw/lib/", "/opt/local/lib"] )

elif "linux2" == os.sys.platform:
    linux = True
    useJavaHome = True
    javaOS = "linux"
    platform = "linux"

    javaHome = choosePathExist( [ javaHome , "/usr/lib/jvm/java/" , os.environ.get( "JAVA_HOME" ) ] , "/usr/lib/jvm/java/" )

    if os.uname()[4] == "x86_64" and not force32:
        linux64 = True

## mongodb 1.4.4

=== SConstruct ===
--- 
+++ 
@@ -19,6 +19,10 @@
 import urllib
 import urllib2
 import buildscripts
+import buildscripts.bb
+from buildscripts import utils
+
+buildscripts.bb.checkOk()
 
 # --- options ----
 AddOption('--prefix',
@@ -37,6 +41,14 @@
           metavar='DIR',
           help='dist name (0.8.0)')
 
+AddOption('--distmod',
+          dest='distmod',
+          type='string',
+          nargs=1,
+          action='store',
+          metavar='DIR',
+          help='additional piece for full dist name')
+
 
 AddOption( "--64",
            dest="force64",
@@ -116,6 +128,13 @@
           action="store",
           help="use java for javascript" )
 
+AddOption('--asio',
+          dest='asio',
+          type="string",
+          nargs=0,
+          action="store",
+          help="Use Asynchronous IO (NOT READY YET)" )
+
 AddOption( "--d",
            dest="debugBuild",
            type="string",
@@ -144,12 +163,27 @@
            action="store",
            help="don't build shell" )
 
+AddOption( "--safeshell",
+           dest="safeshell",
+           type="string",
+           nargs=0,
+           action="store",
+           help="don't let shell scripts run programs (still, don't run untrusted scripts)" )
+
 AddOption( "--extrapath",
            dest="extrapath",
            type="string",
            nargs=1,
            action="store",
-           help="comma seperated list of add'l paths  (--extrapath /opt/foo/,/foo" )
+           help="comma seperated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" )
+
+AddOption( "--extrapathdyn",
+           dest="extrapathdyn",
+           type="string",
+           nargs=1,
+           action="store",
+           help="comma seperated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" )
+
 
 AddOption( "--extralib",
            dest="extralib",
@@ -158,6 +192,20 @@
            action="store",
            help="comma seperated list of libraries  (--extralib js_static,readline" )
 
+AddOption( "--staticlib",
+           dest="staticlib",
+           type="string",
+           nargs=1,
+           action="store",
+           help="comma seperated list of libs to link statically (--staticlib js_static,boost_program_options-mt,..." )
+
+AddOption( "--staticlibpath",
+           dest="staticlibpath",
+           type="string",
+           nargs=1,
+           action="store",
+           help="comma seperated list of dirs to search for staticlib arguments" )
+
 AddOption( "--cxx",
            dest="cxx",
            type="string",
@@ -180,11 +228,31 @@
            action="store",
            help="boost version for linking(1_38)" )
 
+# 
+# to use CPUPROFILE=/tmp/profile
+# to view pprof -gv mongod /tmp/profile
+#
 AddOption( "--pg",
            dest="profile",
            type="string",
            nargs=0,
            action="store" )
+
+AddOption( "--gdbserver",
+           dest="gdbserver",
+           type="string",
+           nargs=0,
+           action="store" )
+
+AddOption("--nostrip",
+          dest="nostrip",
+          action="store_true",
+          help="do not strip installed binaries")
+
+AddOption("--sharedclient",
+          dest="sharedclient",
+          action="store",
+          help="build a libmongoclient.so/.dll")
 
 # --- environment setup ---
 
@@ -231,6 +299,10 @@
 usev8 = not GetOption( "usev8" ) is None
 usejvm = not GetOption( "usejvm" ) is None
 
+asio = not GetOption( "asio" ) is None
+
+justClientLib = (COMMAND_LINE_TARGETS == ['mongoclient'])
+
 env = Environment( MSVS_ARCH=msarch , tools = ["default", "gch"], toolpath = '.' )
 if GetOption( "cxx" ) is not None:
     env["CC"] = GetOption( "cxx" )
@@ -243,6 +315,8 @@
 env.Append( CPPPATH=[ "." ] )
 
 
+if GetOption( "safeshell" ) != None:
+    env.Append( CPPDEFINES=[ "MONGO_SAFE_SHELL" ] )
 
 boostCompiler = GetOption( "boostCompiler" )
 if boostCompiler is None:
@@ -260,14 +334,24 @@
     print( "can't say usesm and usejvm at the same time" )
     Exit(1)
 
-if ( not ( usesm or usejvm or usev8 ) ):
+if ( not ( usesm or usejvm or usev8 or justClientLib) ):
     usesm = True
 
-if GetOption( "extrapath" ) is not None:
-    for x in GetOption( "extrapath" ).split( "," ):
+extraLibPlaces = []
+
+def addExtraLibs( s ):
+    for x in s.split(","):
         env.Append( CPPPATH=[ x + "/include" ] )
         env.Append( LIBPATH=[ x + "/lib" ] )
+        env.Append( LIBPATH=[ x + "/lib64" ] )
+        extraLibPlaces.append( x + "/lib" )
+
+if GetOption( "extrapath" ) is not None:
+    addExtraLibs( GetOption( "extrapath" ) )
     release = True
+
+if GetOption( "extrapathdyn" ) is not None:
+    addExtraLibs( GetOption( "extrapathdyn" ) )
 
 if GetOption( "extralib" ) is not None:
     for x in GetOption( "extralib" ).split( "," ):
@@ -275,12 +359,13 @@
 
 # ------    SOURCE FILE SETUP -----------
 
-commonFiles = Split( "stdafx.cpp buildinfo.cpp db/jsobj.cpp db/json.cpp db/commands.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp shell/mongo.cpp" )
+commonFiles = Split( "stdafx.cpp buildinfo.cpp db/common.cpp db/jsobj.cpp db/json.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp shell/mongo.cpp" )
 commonFiles += [ "util/background.cpp" , "util/mmap.cpp" ,  "util/sock.cpp" ,  "util/util.cpp" , "util/message.cpp" , 
-                 "util/assert_util.cpp" , "util/httpclient.cpp" , "util/md5main.cpp" , "util/base64.cpp", "util/debug_util.cpp"  ]
+                 "util/assert_util.cpp" , "util/httpclient.cpp" , "util/md5main.cpp" , "util/base64.cpp", "util/debug_util.cpp",
+                 "util/thread_pool.cpp" ]
 commonFiles += Glob( "util/*.c" )
-commonFiles += Split( "client/connpool.cpp client/dbclient.cpp client/model.cpp client/parallel.cpp" )
-commonFiles += [ "scripting/engine.cpp" ]
+commonFiles += Split( "client/connpool.cpp client/dbclient.cpp client/model.cpp client/parallel.cpp client/syncclusterconnection.cpp" )
+commonFiles += [ "scripting/engine.cpp" , "scripting/utils.cpp" ]
 
 #mmap stuff
 
@@ -296,11 +381,15 @@
 else:
     commonFiles += [ "util/processinfo_none.cpp" ]
 
-coreDbFiles = []
+coreDbFiles = [ "db/commands.cpp" ]
 coreServerFiles = [ "util/message_server_port.cpp" , "util/message_server_asio.cpp" ]
 
-serverOnlyFiles = Split( "db/query.cpp db/update.cpp db/introspect.cpp db/btree.cpp db/clientcursor.cpp db/tests.cpp db/repl.cpp db/btreecursor.cpp db/cloner.cpp db/namespace.cpp db/matcher.cpp db/dbeval.cpp db/dbwebserver.cpp db/dbinfo.cpp db/dbhelpers.cpp db/instance.cpp db/pdfile.cpp db/cursor.cpp db/security_commands.cpp db/client.cpp db/security.cpp util/miniwebserver.cpp db/storage.cpp db/reccache.cpp db/queryoptimizer.cpp db/extsort.cpp db/mr.cpp s/d_util.cpp" )
+serverOnlyFiles = Split( "db/query.cpp db/update.cpp db/introspect.cpp db/btree.cpp db/clientcursor.cpp db/tests.cpp db/repl.cpp db/btreecursor.cpp db/cloner.cpp db/namespace.cpp db/matcher.cpp db/dbeval.cpp db/dbwebserver.cpp db/dbhelpers.cpp db/instance.cpp db/database.cpp db/pdfile.cpp db/cursor.cpp db/security_commands.cpp db/client.cpp db/security.cpp util/miniwebserver.cpp db/storage.cpp db/reccache.cpp db/queryoptimizer.cpp db/extsort.cpp db/mr.cpp s/d_util.cpp db/cmdline.cpp" )
+serverOnlyFiles += [ "db/index.cpp" ] + Glob( "db/index_*.cpp" )
+
 serverOnlyFiles += Glob( "db/dbcommands*.cpp" )
+serverOnlyFiles += Glob( "db/stats/*.cpp" )
+serverOnlyFiles += [ "db/driverHelpers.cpp" ]
 
 if usesm:
     commonFiles += [ "scripting/engine_spidermonkey.cpp" ]
@@ -308,15 +397,14 @@
 elif usev8:
     commonFiles += [ Glob( "scripting/*v8*.cpp" ) ]
     nojni = True
-elif not nojni:
+elif not (nojni or justClientLib) :
     commonFiles += [ "scripting/engine_java.cpp" ]
 else:
     commonFiles += [ "scripting/engine_none.cpp" ]
     nojni = True
 
 coreShardFiles = []
-shardServerFiles = coreShardFiles + Glob( "s/strategy*.cpp" ) + [ "s/commands_admin.cpp" , "s/commands_public.cpp" , "s/request.cpp" ,  "s/cursors.cpp" ,  "s/server.cpp" , "s/chunk.cpp" , "s/shardkey.cpp" , "s/config.cpp"  ]
-shardServerFiles += [ "client/quorum.cpp" ]
+shardServerFiles = coreShardFiles + Glob( "s/strategy*.cpp" ) + [ "s/commands_admin.cpp" , "s/commands_public.cpp" , "s/request.cpp" ,  "s/cursors.cpp" ,  "s/server.cpp" , "s/chunk.cpp" , "s/shardkey.cpp" , "s/config.cpp" , "s/s_only.cpp" , "db/cmdline.cpp" ]
 serverOnlyFiles += coreShardFiles + [ "s/d_logic.cpp" ]
 
 serverOnlyFiles += [ "db/module.cpp" ] + Glob( "db/modules/*.cpp" )
@@ -327,91 +415,3 @@
     if x.find( "." ) >= 0:
         continue
     print( "adding module: " + x )
-    modRoot = "db/modules/" + x + "/"
-    serverOnlyFiles += Glob( modRoot + "src/*.cpp" )
-    modBuildFile = modRoot + "build.py"
-    if os.path.exists( modBuildFile ):
-        modules += [ imp.load_module( "module_" + x , open( modBuildFile , "r" ) , modBuildFile , ( ".py" , "r" , imp.PY_SOURCE  ) ) ]
-
-allClientFiles = commonFiles + coreDbFiles + [ "client/clientOnly.cpp" , "client/gridfs.cpp" , "s/d_util.cpp" ];
-
-allCXXFiles = allClientFiles + coreShardFiles + shardServerFiles + serverOnlyFiles;
-
-# ---- other build setup -----
-
-platform = os.sys.platform
-if "uname" in dir(os):
-    processor = os.uname()[4]
-else:
-    processor = "i386"
-
-if force32:
-    processor = "i386"
-if force64:
-    processor = "x86_64"
-
-DEFAULT_INSTALl_DIR = "/usr/local"
-installDir = DEFAULT_INSTALl_DIR
-nixLibPrefix = "lib"
-
-distName = GetOption( "distname" )
-dontReplacePackage = False
-
-javaHome = GetOption( "javaHome" )
-javaVersion = "i386";
-javaLibs = []
-
-distBuild = len( COMMAND_LINE_TARGETS ) == 1 and ( str( COMMAND_LINE_TARGETS[0] ) == "s3dist" or str( COMMAND_LINE_TARGETS[0] ) == "dist" )
-if distBuild:
-    release = True
-
-if GetOption( "prefix" ):
-    installDir = GetOption( "prefix" )
-
-def findVersion( root , choices ):
-    for c in choices:
-        if ( os.path.exists( root + c ) ):
-            return root + c
-    raise "can't find a version of [" + root + "] choices: " + choices
-
-def choosePathExist( choices , default=None):
-    for c in choices:
-        if c != None and os.path.exists( c ):
-            return c
-    return default
-
-if "darwin" == os.sys.platform:
-    darwin = True
-    platform = "osx" # prettier than darwin
-
-    if usejvm:
-        env.Append( CPPPATH=[ "-I/System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK/Headers/" ] )
-
-    if not nojni:
-        env.Append( FRAMEWORKS=["JavaVM"] )
-
-    if env["CXX"] is None:
-        if os.path.exists( "/usr/bin/g++-4.2" ):
-            env["CXX"] = "g++-4.2"
-
-    nix = True
-
-    if force64:
-        env.Append( CPPPATH=["/usr/64/include"] )
-        env.Append( LIBPATH=["/usr/64/lib"] )
-        if installDir == DEFAULT_INSTALl_DIR and not distBuild:
-            installDir = "/usr/64/"
-    else:
-        env.Append( CPPPATH=[ "/sw/include" , "/opt/local/include"] )
-        env.Append( LIBPATH=["/sw/lib/", "/opt/local/lib"] )
-
-elif "linux2" == os.sys.platform:
-    linux = True
-    useJavaHome = True
-    javaOS = "linux"
-    platform = "linux"
-
-    javaHome = choosePathExist( [ javaHome , "/usr/lib/jvm/java/" , os.environ.get( "JAVA_HOME" ) ] , "/usr/lib/jvm/java/" )
-
-    if os.uname()[4] == "x86_64" and not force32:
-        linux64 = True

=== debian/changelog ===
mongodb (1:1.4.4-2ubuntu2) maverick; urgency=low

  * Providing a wrapper for xulrunner (LP: #557024)
    - Moves all binaries under /usr/lib/mongodb
    - adds xulwrapper script to mongodb-clients
    - Sets up symlinks to xulwrapper in /usr/bin for all binaries in
      /usr/lib/mongodb
    - Adding dependency on xulrunner-1.9.2 to mongodb-clients as these
      binaries require the library as well.
    - patched SConstruct + buildscripts/hacks_ubuntu.py: removing rpath 
      because wrapper is used
    - Removing debian/mongodb-server.lintian -- rpath is no longer used
    - Removing debian/mongodb-clients.lintian -- rpath is no longer used

 -- Clint Byrum <clint@ubuntu.com>  Tue, 05 Oct 2010 09:33:47 -0500

mongodb (1:1.4.4-2ubuntu1) maverick; urgency=low

  * Merge from debian unstable (LP: #605383). Remaining changes:
    - debian/mongodb-server.mongodb.upstart: add upstart job.
    - Add dependency on xulrunner-1.9.2 since mongodb requires libmozjs.so.
    - Mark mongodb-{server,client,dev} as replacing mongodb to be able to
      upgrade from Lucid.

 -- Angel Abad <angelabad@gmail.com>  Sat, 10 Jul 2010 06:40:58 +0100

mongodb (1:1.4.4-2) unstable; urgency=low

  * [3bd69dc] install libs to /usr/lib not /usr/lib64 (Closes: #588557)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 09 Jul 2010 21:26:05 +0200

mongodb (1:1.4.4-1) unstable; urgency=low

  * [5c6a221] Imported Upstream version 1.4.4
  * upstream change log is at 
    http://jira.mongodb.org/browse/SERVER/fixforversion/10166
  * [68c73c3] removed not needed files from upstream
  * [c1546df] debian policy to 3.9.0

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 30 Jun 2010 09:32:45 +0200

mongodb (1:1.4.3-2ubuntu1) maverick; urgency=low

  [ Clint Byrum ]
  * Merge from Debian unstable (LP: #589566)
    Remaining changes:
    - debian/mongodb-server.mongodb.upstart: add upstart job.

  [ Mathias Gug ]
  * debian/control:
    - Add dependency on xulrunner-1.9.2 since mongodb requires libmozjs.so.
    - Mark mongodb-{server,client,dev} as replacing mongodb to be able to
      upgrade from Lucid.

 -- Mathias Gug <mathiaz@ubuntu.com>  Thu, 10 Jun 2010 15:25:34 -0400

mongodb (1:1.4.3-2) unstable; urgency=low

  * [64bca3c] Updated copyright information as requested by Richard
    Kreuter

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 07 Jun 2010 08:27:36 +0200

mongodb (1:1.4.3-1) unstable; urgency=low

  * New upstream version 1.4.3
  * Change log 1.4.3
    http://jira.mongodb.org/browse/SERVER/fixforversion/10156
  * added log to dirs to fix piuparts error

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 30 May 2010 10:14:05 +0200

mongodb (1:1.4.2-3) unstable; urgency=low

  * Clean up debian/copyright
  * Fix various typos
  * Generally make lintian happy
  * Change section of mongodb-dev from database to libdevel (now matches
    archive override file)
  * Properly express copyrights
  * Fix typo in manpage
  * Remove unused lintian override.
  * Install usr/lib64 instead of usr/lib in mongodb-dev
  * updated watch file to actually work and report available
    stable releases

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 11 May 2010 22:21:13 +0200

mongodb (1:1.4.2-2) unstable; urgency=low

  * Split single binary package into mongodb-server, mongodb-dev, and
    mongodb-clients.

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 06 May 2010 21:20:52 -0400

mongodb (1:1.4.2-1) unstable; urgency=low

  * [4770a09] New upstream version 1.4.2
  * changelog for 1.4.1
    http://jira.mongodb.org/browse/SERVER/fixforversion/10144
  * changelog for 1.4.2
    http://jira.mongodb.org/browse/SERVER/fixforversion/10155

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 27 Apr 2010 19:55:04 +0200

mongodb (1:1.4.0-2) unstable; urgency=low

  * added Roberto C. Sanchez as co-maintainer

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 09 Apr 2010 21:40:49 +0200

mongodb (1:1.4.0-1) unstable; urgency=low

  * [0ca01a9] Imported Upstream version 1.4.0
  * [76c18ea] removed not needed files for debian
  * [c1578d9] merged changes from debianization from 1.2.4
  * full upstream changelog
    http://jira.mongodb.org/secure/IssueNavigator.jspa?requestId=10080
  * upstream release notes
    http://www.mongodb.org/display/DOCS/1.4+Release+Notes

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 25 Mar 2010 19:44:59 +0100 

mongodb (1:1.2.4-1) unstable; urgency=low

  * [c3803a1] Imported Upstream version 1.2.4
  * [ab4e0c8] removal of unnecessary files for Debian from upstream
    source
  * changelog for upstream at 
    http://jira.mongodb.org/browse/SERVER/fixforversion/10130

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 17 Mar 2010 10:18:01 +0100

mongodb (1:1.2.2-4) unstable; urgency=low

  * ensure removal of upstart script as upload of repacked source is failing

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 10 Mar 2010 07:29:38 +0100

mongodb (1:1.2.2-3) unstable; urgency=low

  * [aced2f4] removed unnecessary dependency (Closes: #572873)
  * [ce78acd] Added call for tests to ensure correct build 
    (Closes: #570106)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 07 Mar 2010 21:07:37 +0100

mongodb (1:1.2.2-2) unstable; urgency=low

  * [49232f8] removed upstart, it is buggy + not supported in Debian
    (Closes: #572812)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 06 Mar 2010 22:55:17 +0100

mongodb (1:1.2.2-1ubuntu1) lucid; urgency=low

  [ Richard M Kreuter ]
  * debian/mongodb.conf: uncomment lines to support upstart (LP: #564198)
  * debian/mongodb.upstart: only execute when available (LP: #564202)
  * buildscripts/hacks_ubuntu.py: include nspr in CPPPATH (LP: #557024)
  * scripting/engine_spidermonkey.h: include jsobj.h (LP: #557024)

  [ Emmet Hikory ]
  * Integrate patches (raw): expecting resync when Debian uses new upstream

 -- Emmet Hikory <persia@ubuntu.com>  Fri, 23 Apr 2010 00:43:22 +0900

mongodb (1:1.2.2-1) unstable; urgency=low

  * this commit introduces stable version of MongoDB to Debian, hopefully to


=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Build-Depends: debhelper (>= 7), libpcre3, libpcre3-dev, scons, xulrunner-dev (>= 1.9) | xulrunner-1.9-dev | xulrunner-1.9.1-dev, libboost1.42-dev | libboost1.40-dev | libboost1.35-dev | libboost1.37-dev | libboost1.38-dev, libboost-thread1.42-dev | libboost-thread1.40-dev | libboost-thread1.38-dev | libboost-thread1.37-dev | libboost-thread1.35-dev, libboost-filesystem1.42-dev | libboost-filesystem1.40-dev | libboost-filesystem1.38-dev | libboost-filesystem1.37-dev | libboost-filesystem1.35-dev, libboost-program-options1.42-dev | libboost-program-options1.40-dev | libboost-program-options1.38-dev | libboost-program-options1.37-dev | libboost-program-options1.35-dev, libboost-date-time1.42-dev | libboost-date-time1.40-dev | libboost-date-time1.38-dev | libboost-date-time1.37-dev | libboost-date-time1.35-dev
Standards-Version: 3.9.0
Homepage: http://www.mongodb.org

Package: mongodb
Architecture: i386 amd64
Depends: mongodb-server, mongodb-dev, ${shlibs:Depends}, ${misc:Depends}
Description: An object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free 
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large 
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a metapackage that depends on all the mongodb parts.

Package: mongodb-server
Architecture: i386 amd64
Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser,
 xulrunner-1.9.2
Replaces: mongodb (<= 1:1.4.2-2)
Description: An object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free 
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large 
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself.

Package: mongodb-clients
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends},
 xulrunner-1.9.2
Replaces: mongodb (<= 1:1.4.2-2)
Description: An object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free 
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large 
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the various client applications.

Package: mongodb-dev
Section: libdevel
Architecture: i386 amd64
Depends: mongodb-server, ${shlibs:Depends}, ${misc:Depends}
Replaces: mongodb (<= 1:1.4.2-2)
Description: An object/document-oriented database (development)
 MongoDB is a high-performance, open source, schema-free 
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large 
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 Development headers and libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# debug and nostrip is effectively equivalent for current version of scons
# build system in current mongodb revision
DEB_SCONS_FLAGS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_FLAGS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_FLAGS := --d=DEBUGBUILD
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp  
	dh_testdir

	# Add here commands to compile the package.
	scons $(DEB_SCONS_FLAGS)
	#docbook-to-man debian/mongodb.sgml > mongodb.1

	#run regression tests
	scons --prefix=$(CURDIR)/debian/tmp-test smoke
	rm -rf $(CURDIR)/debian/tmp-test

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	rm -rf $(CURDIR)/debian/tmp
	# FIXME: scons freaks out at the presence of target files
	# under debian/tmp.
	scons -c
	rm -f config.log
	rm -f mongo
	rm -f mongod
	rm -f mongoimportjson
	rm -f mongoexport
	rm -f mongorestore
	rm -f mongodump
	rm -f mongofiles
	rm -f .sconsign.dblite
	rm -f libmongoclient.a
	rm -rf client/*.o
	rm -rf tools/*.o
	rm -rf shell/*.o
	rm -rf .sconf_temp
	rm -f buildscripts/*.pyc 
	rm -f *.pyc
	rm -f buildinfo.cpp
	rm -rf debian/tmp-test
	rm -f debian/mongodb.upstart
	chmod -x debian/xulwrapper
	dh_clean debian/files

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	scons --prefix=$(CURDIR)/debian/tmp/usr install

	mkdir -p $(CURDIR)/debian/tmp/etc
	install -m 644 $(CURDIR)/debian/mongodb.conf \
		$(CURDIR)/debian/tmp/etc/mongodb.conf

	mkdir -p $(CURDIR)/debian/tmp/usr/share/man/man1
	install -m 644 $(CURDIR)/debian/*.1 \
		$(CURDIR)/debian/tmp/usr/share/man/man1
	chmod +x debian/xulwrapper


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit -pmongodb-server --name=mongodb
#	dh_installinfo
	dh_installman
	for i in `ls debian/mongodb-server/usr/lib/mongodb` ; do dh_link -p mongodb-server usr/lib/mongodb/xulwrapper usr/bin/$$i ; done
	for i in `ls debian/mongodb-clients/usr/lib/mongodb` ; do if [ "$$i" != "xulwrapper" ] ; then dh_link -p mongodb-clients usr/lib/mongodb/xulwrapper usr/bin/$$i ; fi ; done
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# examine the content of the downloads page as the directory listing
# is not allowed anymore
#
# Forced regexp to match only to the current stable release
http://www.mongodb.org/display/DOCS/Downloads \
  http://downloads\.mongodb\.org/src/mongodb-src-r(1\.4[\d\.]+)\.tar\.gz
